#define DOCTEST_CONFIG_NO_MULTITHREADING
#define DOCTEST_CONFIG_IMPLEMENT_WITH_MAIN
#include "doctest.h"
#include "histogam_internal.h"
#include <vector>

TEST_CASE("distinct positive numbers") {
    double min = 0;
    double max = 0;
    std::vector<double>f{1,2};

    find_minmax(f, min, max);
    CHECK(min == 1);
    CHECK(max == 2);
    CHECK(min != max);
}

TEST_CASE("distinct positive numbers") {
    double min = 0;
    double max = 0;
    std::vector<double>f{};
    CHECK(find_minmax(f, min, max) != 0);
    CHECK(f.size() != 1);
    find_minmax(f, min, max);
    CHECK(min == 1);
    CHECK(max == 2);
    CHECK(min != max);
}
TEST_CASE("void vector") {
    double min = 3;
    double max = 2;
     std::vector<double> numbers {};
     bool check = find_minmax(numbers, min, max);
    CHECK(check == true);
}
TEST_CASE("vector with same elements") {
    double min = 0;
    double max = 0;
    find_minmax({2,2,2}, min, max);
    CHECK(min == 2);
    CHECK(max == 2);
}
TEST_CASE("vector with one element") {
    double min = 0;
    double max = 0;
    find_minmax({1}, min, max);
    CHECK(min == 1);
    CHECK(max == 1);
}
